///////////////////////////////////////////////////////////////////////
//
// David Cheung
// U49303740
// CS 540: AI
// HW 2
// Feb 24, 1999
//////////////////////////////////////////////////////////////////////
// AI.cpp: implementation of the AI class.
//
//////////////////////////////////////////////////////////////////////


#include "AI.h"
#include "stdio.h"
#include "linklist.h"
#include "node.h"
#include <math.h>
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AI::AI()
{
	goal[0]=1;
	goal[1]=2;
	goal[2]=3;
	goal[3]=4;
	goal[4]=5;
	goal[5]=6;
	goal[6]=7;
	goal[7]=8;
	goal[8]=9;
	maxdepth=25;
	elm = new tree;
	q = new linklist;
	tabloid = new reporter;
}

AI::~AI()
{

}

void AI::arraycp(int arraysource[], int arraydest[])
{
	int tmp_int=0;
	for(tmp_int=0;tmp_int<9;tmp_int++)
	{
		arraydest[tmp_int]=arraysource[tmp_int];
	}

}

bool AI::sucessor(char stype, char htype)
{
	// The sucessor function is suppose to take in a 
	// node and expand it according to available
	// operators and then stick them in the trees
	// and queues. 
	// Modified 2/22/99: for types:
	//			q = quick heuristic, ie, # of wrong tiles.
	//			m = manhattan heuristic, ie, sum of # of moves
	//				to the destination tile for each tile.
	//			h and e are no longer used, since it was
	//			used for the queueing methode, now that the
	//			queueing method is the same for both of 
	//			them, type will use to denote different
	//			type of heristic function.

	node *nodemaker;
	if (elm->numnode==0)
	{
		// if the tree has no nodes, then make an
		// initial state.
		nodemaker = new node;
		// report
		//
		tabloid->nodesgenperinstance++;
		//
		//
		nodemaker->stuffdata(init);
		elm->addnode(nodemaker);
		q->addnode(nodemaker);
		//REPORT
		//
		tabloid->statesconsidered++;

		if(goaltest(nodemaker))
		{
			//REPORT
			//
			tabloid->depth=nodemaker->depth;
			return true;

		}
		else return false;
	}
	nodemaker=q->pop(); // pop out from the queue's head
	elm->curptr=nodemaker;

	//REPORT
	//
	tabloid->statesconsidered++;
	//goal test: if goal test true, then end search!
	//
	if(goaltest(nodemaker)) 
	{
		//REPORT
		//
		tabloid->depth=nodemaker->depth;
		return true;
	}
	if(nodemaker->depth >= maxdepth) 
	{
		return false;
	}
	int thenine;
	thenine=AI::wherenine(nodemaker);
	int i=0;
	node *nodechild;
	listavailop(nodemaker);
	for (i=0;i<4;i++)
	{
		if(availop[i]==1)
		{
			// at this point...will try to create
			// the most number of child states
			nodechild=new node(nodemaker);
			// report
			//
			tabloid->nodesgenperinstance++;
			//
			//

			if (i==0)
			{
				// move left is available.
				operation(nodechild,thenine,'l');
			}
			if (i==1) operation(nodechild,thenine,'r');
			if (i==2) operation(nodechild,thenine,'u');
			if (i==3) operation(nodechild,thenine,'d');
		
//			if (elm->querydata(nodechild))
			// 2/23/99: instead of using querydata,
			// i'm planing to search the whole tree istead
			// of just its path. The reason being best first
			// search spawns undetected loops .
			// The new ismember searches for the entire tree
			// for duplicate states
//			if (elm->ismember(nodechild))
			// 2/23/99: I've tried ismember which searched the
			// entire tree and found it very inefficient, so
			// i've borrowed John Wong's idea of hashtable.
			// hashtable is a huge array of 362880 of bool.
			// hashtable tells if the hash function: conversionfactor
			// has been visited or not.
			if (elm->hashtable[elm->conversionfactor(nodechild->data)])
				delete nodechild;
			else
			{
				// 2/22/99: INSERT EVALUATIONG FUNCTION HERE
				//
				elm->addnode(nodechild);
				elm->hashtable[elm->conversionfactor(nodechild->data)]=true;
				nodechild->pathcost=evalfn(nodechild,stype,htype);
				// if type is 'h', then enqueue at head.
				// else enqueue at end.
				// by default it is enqueue at head, and
				// pop function by default enqueue
				// 2/22/99: for HW2, both heuristic functions
				// will need sorted queue, so there's no
				// choice this time....
				q->addnode(nodechild, 's');
				// 
				// reporting..
				//
				tabloid->numstatesgenerated++;
			}
		}

	}
	return false;
	// sucessor function tested and worked correctly.

}

bool AI::goaltest(node *tnode)
{
	bool flag=true;
	int i=0;
	for (i=0;i<9;i++)
	{
		if (!(tnode->data[i]==goal[i]))
		{
			flag=false;
		}
	}
	return flag;
}

void AI::operation(node *tnode, int nineis, char op)
{
	if(op=='l')
	{
		// attempt to move nineis to the left...
		swapcell(tnode->data, nineis, nineis-1);
	}
	else 
	{
		if(op=='r')
		{
			// attempt to move nineis to the right
			swapcell(tnode->data, nineis, nineis+1);
		}
		else
		{
			if(op=='u') swapcell(tnode->data, nineis, nineis-3);
			else
			{
				if(op=='d') swapcell(tnode->data,
								nineis, nineis+3);
			}
		}
	}
}

void AI::swapcell(int array[], int a, int b)
{
	int tmp;
	tmp=array[a];
	array[a]=array[b];
	array[b]=tmp;
}

int AI::wherenine(node *tnode)
{
	// this function return the numeric value
	// of the cell where the nine is...
	int tmp=0;
	for (tmp=0; tmp<9;tmp++)
	{
		if(tnode->data[tmp]==9)
			return tmp;
	}
	return 0;
}

void AI::listavailop(node *tnode)
{
	availop[0]=0;
	availop[1]=0;
	availop[2]=0;
	availop[3]=0;
	int nine;
	nine=wherenine(tnode);
	if ((!(nine==2) && !(nine==5) && !(nine==8)))
		availop[1]=1;  // can move right
	if ((!(nine==0) &&
		!(nine==3) &&
		!(nine==6)))
		availop[0]=1;	// can move left
	if ((!(nine==0) &&
		!(nine==1) &&
		!(nine==2)))
		availop[2]=1;	// can move up
	if ((!(nine==6) &&
		!(nine==7) &&
		!(nine==8)))
		availop[3]=1;	// can move down

}

void AI::depthsearch(char stype, char htype)
{
	// 2/22/99: stypes and htypes:
	// stype parameters are: b and a: best first and admissive
	// htype parameters are: q and m: quick heuristic and manhantan distance.
	int i=0;
	maxdepth=30;
	bool solutionfoundyet=false;
	bool failed=false;  // fail solution flag
	fprintf(ofp,"performing quick heuristic search...\n");
	testnode.stuffdata(init);
	tabloid->initnode.stuffdata(init);
	fprintf(ofp, "For instance :");
	testnode.printfile(ofp);
	
	do
	{
		solutionfoundyet=sucessor(stype,htype);
		
		i++;
		if(q->numnode==0 && !(i==0)) failed=true;
	}while( !failed && !solutionfoundyet);


	if(q->numnode==0)
		fprintf(ofp," search failed! all solutions exhausted.\n");
	else
	{
		fprintf(ofp," Solution found! the solution is: \n");
		elm->printpathfile(ofp);
	}

//	int i=0;
//	maxdepth=30;
//	bool solutionfoundyet=false;
//	bool failed=false;  // fail solution flag
//	if(stype=='b')	fprintf(ofp,"performing best-first-search...\n");
//	else fprintf(ofp,"performing admissible-search...\n");
//	if(htype=='q') fprintf(ofp, "Heuristic: quick...\n");
//	else fprintf(ofp, "Heuristic: manhattan heuristic...\n");
//	testnode.stuffdata(init);
//	tabloid->initnode.stuffdata(init);
//	fprintf(ofp, "For instance :");
//	testnode.printfile(ofp);
//	
//	do
//	{
//		solutionfoundyet=sucessor(stype,htype);
//		
//		i++;
//		if(q->numnode==0 && !(i==0)) failed=true;
//	}while( !failed && !solutionfoundyet);
//
//
//	if(q->numnode==0)
//		fprintf(ofp," search failed! all solutions exhausted.\n");
//	else
//	{
//		fprintf(ofp," Solution found! the solution is: \n");
//		elm->printpathfile(ofp);
//	}
//
}



void AI::taskengine(char stype, char htype)
{
	// if the type is "b" then implies breath search
	// if type is "d" then implies depth search
	// if type is "i" then implies iterative deepening search.
	// if type is "q" then implies quick heuristic search
	// if type is 'm' then imples manhattan heuristic search

	FILE *ifp; // input file pointer
	ifp=fopen("assn1.txt","r");
	int tmp[9];
	//reset a tabloid:
	delete tabloid;
	tabloid = new reporter;
	// report
	//
	tabloid->searchtype=stype;
	tabloid->heurtype=htype;

	switch (stype)
	{
		case 'b': 	
					if(htype=='q')
					{
						ofp=fopen("bestquickout.txt","w");
						tabloid->getofp(fopen("bestquickrep.txt","w"));
					}
					else
					{	//htype is probably 'm'
						ofp=fopen("bestmanout.txt","w");
						tabloid->getofp(fopen("bestmanrep.txt","w"));
					}
					break;
		case 'a':
					if(htype=='q')
					{
						ofp=fopen("admisquickout.txt","w");
						tabloid->getofp(fopen("admisquickrep.txt","w"));
					}
					else
					{	//htype is probably 'm'
						ofp=fopen("admismanout.txt","w");
						tabloid->getofp(fopen("admismanrep.txt","w"));
					}
					break;

	}

	int counter=0;
	time(&tabloid->overall_start_time);

	while(	(fscanf(ifp,"%d %d %d %d %d %d %d %d %d \n",
			&tmp[0],&tmp[1],&tmp[2],
			&tmp[3],&tmp[4],&tmp[5],
			&tmp[6],&tmp[7],&tmp[8]) >=0))
	{
		arraycp(tmp,AI::init);
		// Record time change
		time(&tabloid->start_time);
		switch (stype)
		{
			case 'b': 
						if(htype=='q') hquicksearch('b');
						else hmansearch('b');
						break;
			case 'a':	
						if(htype=='q') hquicksearch('a');
						else hmansearch('a');
						break;
		}
		// Record time changes
		time(&tabloid->finish_time);
		tabloid->instancereport();
		tabloid->instancereset();
		counter++;
		printf("%d\n",counter);
		AI::clean(); // cleans the tree and q every
					// instance.
	}
	time(&tabloid->overall_finish_time);
	tabloid->overallreport();
//	
//	
}

void AI::clean()
{
	// cleans the tree and q's and create them again.
	delete elm;
	delete q;
	elm=new tree;
	q=new linklist;
}

int AI::heurquick(int array[])
{
	//This quick heuristic function returns number of tiles
	// that are wrong....
	// eg: instance of [3,2,1,4,6,7,5,9,8] will return
	// 8.
	int i=0;
	int answer=0;
	for(i=0;i<9;i++)
	{
		if(!(array[i]==(i+1))) answer++;
	}
	return answer;
}

int AI::evalfn(node *znode, char stype, char htype)
{
	int gvalue=0;
	int hvalue=0;
	int newcost;
	int parentcost=0;
	gvalue=znode->depth;
	if(htype=='q')
	{
		hvalue=heurquick(znode->data);
	}
	else
	{
		if(htype=='m') hvalue=heurman(znode->data);
	}

	if(stype=='a')
	{
	newcost=gvalue + hvalue;
	}
	else
	{
		newcost=hvalue;
	}
	if(znode->parent)parentcost=znode->parent->pathcost;
//	else parentcost=0;
// page 98 function cost. for addmissive search

		if(parentcost>newcost) return parentcost;
		else return newcost;
}

void AI::hquicksearch(char stype)
{
	int i=0;
	maxdepth=25;
	bool solutionfoundyet=false;
	bool failed=false;  // fail solution flag
	fprintf(ofp,"performing quick heuristic search...\n");
	switch (stype)
	{	case 'b': 
			fprintf(ofp,"Best first method...\n");
			break;
		case 'a':
			fprintf(ofp,"A* method...\n");
			break;
	}

	testnode.stuffdata(init);
	tabloid->initnode.stuffdata(init);
	fprintf(ofp, "For instance :");
	testnode.printfile(ofp);
	
	do
	{
		solutionfoundyet=sucessor(stype,'q');
		
		i++;
		if(q->numnode==0 && !(i==0)) failed=true;
	}while( !failed && !solutionfoundyet);


	if(q->numnode==0)
		fprintf(ofp," search failed! all solutions exhausted.\n");
	else
	{
		fprintf(ofp," Solution found! the solution is: \n");
		elm->printpathfile(ofp);
	}


}

int AI::heurman(int array[])
{
	int i=0;
	int k=0;
	int j = 0;
	int l=0;
	for(i=0;i<9;i++)
	{
		k=((array[i] -1) /3) - (i /3);
		l=((array[i] - 1) % 3) - (i % 3);
		if(k < 0) k= -k;
		if(l < 0) l = -l;
		j= k + l + j;
	}
	return j;

}

void AI::hmansearch(char stype)
{
	int i=0;
	maxdepth=25;
	bool solutionfoundyet=false;
	bool failed=false;  // fail solution flag
	fprintf(ofp,"performing manhattan heuristic search...\n");
	switch (stype)
	{	case 'b': 
			fprintf(ofp,"Best first method...\n");
			break;
		case 'a':
			fprintf(ofp,"A* method...\n");
			break;
	}


	testnode.stuffdata(init);
	tabloid->initnode.stuffdata(init);
	fprintf(ofp, "For instance :");
	testnode.printfile(ofp);
	
	do
	{
		solutionfoundyet=sucessor(stype,'m');
		
		i++;
		if(q->numnode==0 && !(i==0)) failed=true;
	}while( !failed && !solutionfoundyet);


	if(q->numnode==0)
		fprintf(ofp," search failed! all solutions exhausted.\n");
	else
	{
		fprintf(ofp," Solution found! the solution is: \n");
		elm->printpathfile(ofp);
	}


}

/////////////////////////////////////////////////////////////////////
// reporter Class
//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

reporter::reporter()
{
	statesconsidered=0;
	statesgenpernode=0;
	nodesgenperinstance=0;
	numstatesgenerated=0;
	depth=0;
	initnode=0;
	maxstates=0;
	minstates=0;
	numinstances=0;
	cumstates=0;
	avestates=0;
	cumtime=0;
	cum_branch_factor=0;
	sumnumnodesgenperinstancesquared=0;


}

reporter::~reporter()
{

}

void reporter::getofp(FILE *fptr)
{
	ofp=fptr;
}


void reporter::overallreport()
{
	avestates=(float)cumstates / (float)numinstances;
	fprintf(reporter::ofp, "*********************************\n");
	fprintf(reporter::ofp, "Overall Report:\n");
	fprintf(reporter::ofp, "Search Type: ");
	switch (reporter::searchtype)
	{
	case 'b': fprintf(reporter::ofp, "Best first\n");
			break;
	case 'a': fprintf(reporter::ofp, "Admissive first \n");
			break;
	default:
			fprintf(reporter::ofp, "Unknown \n");
			break;
	}
	switch (reporter::heurtype)
	{
	case 'q': fprintf(reporter::ofp, "Quick Heuristic\n");
			break;
	case 'm': fprintf(reporter::ofp, "Manhattan Heuristic \n");
			break;
	default:
			fprintf(reporter::ofp, "Unknown \n");
			break;
	}
	float tmptime=0;
	float ave_branch_factor=0;
	ave_branch_factor=cum_branch_factor / numinstances;
	double std_deviation=0;
	std_deviation= sqrt( (double)abs((numinstances*reporter::sumnumnodesgenperinstancesquared -
		(cumstates^2)))/(numinstances*(numinstances-1)));
	tmptime=(float)difftime(reporter::overall_finish_time, reporter::overall_start_time);
	fprintf(reporter::ofp, "Num of Instances worked: %d\n", numinstances);
	fprintf(reporter::ofp, "Max states generated : %d\n",maxstates);
	fprintf(reporter::ofp, "Min states generated : %d\n",minstates);
	fprintf(reporter::ofp, "Ave states generated : %.2f\n",avestates);
	fprintf(reporter::ofp, "Standard Deviation : %.2f\n",std_deviation);
	fprintf(reporter::ofp, "Average branch factor: %.2f\n", ave_branch_factor);
	fprintf(reporter::ofp, "Total time in seconds: %.0f\n", tmptime);
	fprintf(reporter::ofp, "*********************************\n");

}

void reporter::instancereport()
{
	float elapse_time=0;
	fprintf(reporter::ofp, "*********************************\n");
	fprintf(reporter::ofp, "Instance : ");
	reporter::initnode.printfile(reporter::ofp);
	fprintf(reporter::ofp, "Search type : ");
	switch (reporter::searchtype)
	{
	case 'b': fprintf(reporter::ofp, "Best first\n");
			break;
	case 'a': fprintf(reporter::ofp, "Admissive first \n");
			break;
	default:
			fprintf(reporter::ofp, "Unknown \n");
			break;
	}
	switch (reporter::heurtype)
	{
	case 'q': fprintf(reporter::ofp, "Quick Heuristic\n");
			break;
	case 'm': fprintf(reporter::ofp, "Manhattan Heuristic \n");
			break;
	default:
			fprintf(reporter::ofp, "Unknown \n");
			break;
	}
	elapse_time=(float)difftime(reporter::finish_time, reporter::start_time);
//
//	elapse_time=(float) (finish_time - start_time) / CLOCKS_PER_SEC;

	float branch_factor=0;
	branch_factor=(float)(reporter::numstatesgenerated) / (float)(reporter::statesconsidered);
	printf("Time took in seconds: %.0f\n",elapse_time);
	cumtime=cumtime+elapse_time;
	fprintf(reporter::ofp, "Depth of goal state: %d\n",reporter::depth);
	fprintf(reporter::ofp, "Nodes generated : %d \n", nodesgenperinstance);
	fprintf(reporter::ofp, "States generated : %d \n", numstatesgenerated);
	fprintf(reporter::ofp, "States considered : %d \n",statesconsidered);
	fprintf(reporter::ofp, "Time took in seconds: %.0f \n", elapse_time);

	fprintf(reporter::ofp, "Branch Factor: %.2f \n", branch_factor);	
	fprintf(reporter::ofp, "*********************************\n");
	cum_branch_factor = cum_branch_factor + branch_factor;
	int numnodessquared=0;
	numnodessquared=nodesgenperinstance * nodesgenperinstance;
	reporter::sumnumnodesgenperinstancesquared = 
		reporter::sumnumnodesgenperinstancesquared + numnodessquared;
}


void reporter::instancereset()
{
	cumstates=cumstates+numstatesgenerated;

	numinstances++;
	if(maxstates<numstatesgenerated) maxstates=numstatesgenerated;
	if((minstates==0) || (minstates > numstatesgenerated))
		minstates=numstatesgenerated;
	reporter::nodesgenperinstance=0;
	reporter::numstatesgenerated=0;
	reporter::statesconsidered=0;

}


