///////////////////////////////////////////////////////////////////////
//
// David Cheung
// U49303740
// CS 540: AI
// HW 2
// Feb 24, 1999
//////////////////////////////////////////////////////////////////////
// linklist.cpp: implementation of the linklist class.
//
//////////////////////////////////////////////////////////////////////

#include "linklist.h"
#include "node.h"
#include "stdio.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


linklist::linklist()
{
// The linklist is designed as follows:
// The head points to the top node;
// the top node has prev and next.
// the top node's next points to the next node
// and next node points to the top node.
// Both ends of the node points to NULL
// END pointer points to the last node....after 
// all the next's.....
	//
	//
	//   head ->	------
	//				|  p |
	//				|    |
	//				|  N |
	//				------
	//					|
	//					|
	//				------
	//				|  p |
	//				|    |
	//	end->		|  N |
	//				------
	//					
// REMEMBER:
// when queueing at the end, it will be FIFO, when
// queueing at the head, it sill LIFO
// As of 2/22/99, I have changed default to 
// queueing at the end, but for AI's, its
// default if 'h', that is queueing at the 
// head...

	linklist::head=NULL;
	linklist::end=NULL;
	numnode=0;
	
}

linklist::~linklist()
{

}

void linklist::addnode(node* nwnode,char type)
{
	//puts a node in this link list.
	// this does not "create" a node
	// since a node has already been 
	// created.
	// by default it will add to the head, but
	// if addnode is invoked with another letter
	// other than 'h', it will add from the end.

	// 2/22/99:
	// need to add a sorting function....need to
	// keep queue in sorted order by node cost....
	// a type of 's' will denote sorted add...and
	// will call up a new private function.

	node* tmpnode;
	tmpnode= nwnode;
	node* oldhead;
	oldhead=head;
	// check if adding on a null list:
	// kinda messy...
	if (numnode==0) 
	{
		linklist::head=tmpnode;
		linklist::end=tmpnode;
	}
	else
	{
		//puts the new node on the top.
		//did some relinking....
		//remember the node does NOT point to
		// the head, but the head points to
		// the top node. This way I can start
		// a recursion and end it by a null.
	
		if(type=='h')
		{	
			head->prev=tmpnode;
			tmpnode->next=head;
			head=tmpnode;
		}
		else
		{
			if(type=='s')
			{
				sortedaddnode(nwnode);
			}
			else
			{

				end->next=tmpnode;
				tmpnode->prev=end;
				end=tmpnode;
			}
		}
	}
		
	numnode++;


}


void linklist::listprint()
{
	node* ptr;
	ptr=linklist::head;
	while(ptr)
	{
		ptr->printdata();
		ptr=ptr->next;
	}
	printf("\n");

}


void linklist::listdata()
{

	node* ptr;
	ptr=linklist::head;
	while(ptr)
	{
		ptr->printdata();
		ptr=ptr->next;
	}



}

node *linklist::pop()
{
	node* tmp_ptr;
	tmp_ptr=linklist::head;
	if(numnode == 0) return NULL;

	if (numnode <=1)
	{
		head=NULL;
		end=NULL;
	}
	else
	{
		head->next->prev=NULL;
		head=head->next;
		tmp_ptr->next=NULL;
	}

	numnode--;
	return tmp_ptr;

}

void linklist::sortedaddnode(node *nwnode)
{
	// The sorted addnode is added 2/21/99.
	// Its purpose is to try to keep the nodes
	// sorted at all times so that it doeesn't have
	// to run a big sort everytime.
	// the average time of this function is n where
	// n is the number of nodes. The assumption is
	// that the list is sorted already. So Adding
	// a new node is just a matter of finding
	// the right insertion point. Also, this 
	// function is called by addnode function, and
	// in that function, empty link list is already
	// taken care of. So this function will need
	// to find the right insertion point and
	// perform the insertion. 
	// 
	// if the list is very large, would searching from
	// the end faster than searching from the beginning?
	// don't know!
	node *tmpnode;
	tmpnode=nwnode;
	node *curpointer; 
	curpointer=head;
	while(curpointer)
	{
		if(nwnode->pathcost < curpointer->pathcost)
		{
			insertnode(curpointer, nwnode, 'b');
			return;
		}
		else 
		{
			if(curpointer->next)
				curpointer=curpointer->next;
			else
			{
				// if at this point still haven't been inserted yet, then
				// probably need to add it at the end...
				insertnode(curpointer,nwnode,'a');
				return;
			}
		}
	}
	//2/22/99:
	// This function has been tested and is able to add a new node
	// anywhere....
}

void linklist::insertnode(node *curptr, node *nwnode, char type)
{
//	node *tmpnode;
//	tmpnode=nwnode;
	if(type=='b')
	{
	// Added 2/22/91
	// This function will insert a node BEFORE
	// the curptr node.
		nwnode->next=curptr;
		nwnode->prev=curptr->prev;
		if(curptr->prev) curptr->prev->next=nwnode; // what if there's no previous node??
		else head=nwnode; // if there's no previous node, then the new node is on the
						  // top, so we need to more the head pointer too.
		curptr->prev=nwnode;

	}
	if(type=='a')
	{
		// This will insert a node AFTER
		// the curptr node.
		// like previously, what if there's no next node?
		// this would imply the curptr is at the end, so
		// we would need to move the end pointer too.
		if(curptr->next) curptr->next->prev=nwnode;
		else end= nwnode;
		nwnode->next=curptr->next;
		nwnode->prev=curptr;
		curptr->next=nwnode;
	}
	// 2/22/91:
	// This function has been thoroughly tested and works fine!
	// verification is done via listprint to see the entire list.
}
